<?php
/*------------------------------------------------------------------------
# helper.php - mod_ospropertysearch
# ------------------------------------------------------------------------
# author    Dang Thuc Dam
# copyright Copyright (C) 2010 joomdonation.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomdonation.com
# Technical Support:  Forum - http://www.joomdonation.com/forum.html
*/

defined('_JEXEC') or die('Restricted access');

class modOspropertyGoogleMapHelper
{
	private $params;
	/**
	 * Enter description here...
	 *
	 */
	public function loadLanguage(){
		JFactory::getLanguage()->load('com_osproperty', JPATH_SITE, JFactory::getLanguage()->getTag(), true);
	}
	
	/**
	 * get configuation of property
	 *
	 */
	public static function getConfig(){
		$db = JFactory::getDbo();
		$db->setQuery("Select * from #__osrs_configuration");
		$configs = $db->loadObjectList();
		$configClass = array();
		foreach ($configs as $config) {
			$configClass[$config->fieldname] = $config->fieldvalue;
		}
		return $configClass;
	}
	
	public static function loadAllProperty($osp_category,$osp_type,$osp_countries,$state_ids,$city_ids,$maxitem,$bootstrap,$params){
		global $mainframe,$lang_suffix;
		$configClass = self::getConfig();
		$languages = OSPHelper::getLanguages();
		$translatable = JLanguageMultilang::isEnabled() && count($languages);
		if($translatable){
			//generate the suffix
			$lang_suffix = OSPHelper::getFieldSuffix();
		}

		$user = JFactory::getUser();
		$db = JFactory::getDbo();
		$query = "Select a.id,a.pro_name,a.pro_name$lang_suffix,a.address,a.state,a.city,a.country,a.show_address,a.price,a.price_call,a.postcode,a.region,a.lat_add,a.long_add,a.pro_type,c.name as agent_name,c.photo as agent_photo,c.email as agent_email,d.id as typeid,d.type_name$lang_suffix as type_name,e.country_name from #__osrs_properties as a"
				." INNER JOIN #__osrs_agents as c on c.id = a.agent_id"
				." LEFT JOIN #__osrs_types as d on d.id = a.pro_type"
				." LEFT JOIN #__osrs_countries as e on e.id = a.country"
				." WHERE 1=1";
		if(intval($user->id) > 0){
			$special = HelperOspropertyCommon::checkSpecial();
			if($special){
				$query .= " and a.`access` in (0,1,2) ";
			}else{
				$query .= " and a.`access` in (0,1) ";
			}
		}else{
			$query .= " and a.`access` = '0' ";
		}
		if((count($osp_countries) > 0) and ($osp_countries[0] > 0)){
			$query .= " and a.country in (".implode(",",$osp_countries).")";
		}
		if($state_ids != ""){
			$query .= " and a.state in ($state_ids)";
		}
		if($city_ids != ""){
			$query .= " and a.city in ($city_ids)";
		}
		if((count($osp_category) > 0) and ($osp_category[0] > 0)){
			$query .= " and a.id in (Select pid from #__osrs_property_categories where category_id in (".implode(",",$osp_category)."))";
		}
		if((count($osp_type) > 0) and ($osp_type[0] > 0)){
			$query .= " and a.pro_type in (".implode(",",$osp_type).")";
		}
		$query .= " and a.show_address = '1' and a.published = '1' and a.approved = '1'";
		if($maxitem > 0){
			$query .= " limit $maxitem";
		}	
	
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if(count($rows) > 0){
			for($i=0;$i<count($rows);$i++){
				$row = $rows[$i];

				$db->setQuery("Select category_id from #__osrs_property_categories where pid = '$row->id'");
				$row->category_id = $db->loadResult();

				$db->setQuery("Select image from #__osrs_photos where pro_id = '$row->id'");
				$image = $db->loadResult();
				$address = OSPHelper::generateAddress($row);
				$address = str_replace("'","",$address);
				$row->address = $address;
				$needs = array();
				$needs[] = "property_details";
				$needs[] = $row->id;
				$itemid = OSPRoute::getItemid($needs);
				$link = JRoute::_('index.php?option=com_osproperty&task=property_details&id='.$row->id.'&Itemid='.$itemid);
				ob_start();
				
				if($bootstrap == "bootstrap2"){
				?><div class="row-fluid"><div class="span4"><?php if($image != ""){ if(file_exists(JPATH_ROOT.'/images/osproperty/properties/'.$row->id.'/medium/'.$image)){ ?><a href="<?php echo $link?>" title="<?php echo JText::_('OS_PROPERTY_DETAILS');?>"><img src="<?php echo JURI::root()?>images/osproperty/properties/<?php echo $row->id?>/medium/<?php echo $image?>" class="span12 thumbnail" width="150" alt="<?php echo str_replace("'","",OSPHelper::getLanguageFieldValue($row,'pro_name'));?>"></a><?php }else{ ?><a href="<?php echo $link?>" title="<?php echo JText::_('OS_PROPERTY_DETAILS');?>"><img src="<?php echo JURI::root()?>components/com_osproperty/images/assets/nopropertyphoto.png" class="span12 thumbnail" alt="<?php echo str_replace("'","",OSPHelper::getLanguageFieldValue($row,'pro_name'));?>"></a><?php } }else{ ?><a href="<?php echo $link?>" title="<?php echo JText::_('OS_PROPERTY_DETAILS');?>"><img src="<?php echo JURI::root()?>components/com_osproperty/images/assets/nopropertyphoto.png" class="span12 thumbnail" alt="<?php echo str_replace("'","",OSPHelper::getLanguageFieldValue($row,'pro_name'));?>"></a><?php } ?></div><div class="span8"><span class="mod_ospropertymap_title"><a href="<?php echo $link?>" title="<?php echo JText::_('OS_PROPERTY_DETAILS');?>"><?php
						if($row->ref != ""){
							echo $row->ref.", ";
						} echo str_replace("'","",OSPHelper::getLanguageFieldValue($row,'pro_name')); ?></a></span><BR /><span class="mod_ospropertymap_price"><?php
						if($row->price_call == 0){
							echo OSPHelper::generatePrice($row->curr,$row->price);
						}
						?></span><BR /><?php echo $row->address;?></div></div><?php
				}elseif($bootstrap == "bootstrap3"){
				?><div class="row"><div class="col-md-4"><?php if($image != ""){ if(file_exists(JPATH_ROOT.'/images/osproperty/properties/'.$row->id.'/medium/'.$image)){ ?><a href="<?php echo $link?>" title="<?php echo JText::_('OS_PROPERTY_DETAILS');?>"><img src="<?php echo JURI::root()?>images/osproperty/properties/<?php echo $row->id?>/medium/<?php echo $image?>" class="img-polaroid" width="150" alt="<?php echo str_replace("'","",OSPHelper::getLanguageFieldValue($row,'pro_name'));?>"></a><?php }else{ ?><a href="<?php echo $link?>" title="<?php echo JText::_('OS_PROPERTY_DETAILS');?>"><img src="<?php echo JURI::root()?>components/com_osproperty/images/assets/nopropertyphoto.png" class="img-polaroid" alt="<?php echo str_replace("'","",OSPHelper::getLanguageFieldValue($row,'pro_name'));?>"></a><?php } }else{ ?><a href="<?php echo $link?>" title="<?php echo JText::_('OS_PROPERTY_DETAILS');?>"><img src="<?php echo JURI::root()?>components/com_osproperty/images/assets/nopropertyphoto.png" class="img-polaroid" alt="<?php echo str_replace("'","",OSPHelper::getLanguageFieldValue($row,'pro_name'));?>"></a><?php } ?></div><div class="col-md-8"><span class="mod_ospropertymap_title"><a href="<?php echo $link?>" title="<?php echo JText::_('OS_PROPERTY_DETAILS');?>"><?php
					if($row->ref != ""){
						echo $row->ref.", ";
					} echo str_replace("'","",OSPHelper::getLanguageFieldValue($row,'pro_name')); ?></a></span><BR /><span class="mod_ospropertymap_price"><?php
					if($row->price_call == 0){
						echo OSPHelper::generatePrice($row->curr,$row->price);
					}
					?></span><BR /><?php echo $row->address;?></div></div><?php
				}
				$row->infowindow = ob_get_contents();
				ob_end_clean();
			}
		}
		return $rows;
	}
	
	
	public static function createMap($params, $width = null, $height = null, $zoom = null,$module_id) {
        $doc = JFactory::getDocument();
        //$items = self::loadAllProperty(); //$this->_rows;
        $db = JFactory::getDbo();
        
        $width = $params->get('width','100%');
		$height = $params->get('height',300);
		$zoom = $params->get('zoom',10);
		$map_type = $params->get('map_type','google');
		$bing_api = $params->get('bing_api','');
		$google_maptype = $params->get('google_maptype','ROADMAP');
		$bing_maptype = $params->get('bing_maptype','road');
		$osp_category = $params->get('osp_category');
		$osp_type = $params->get('osp_type');
		$maxitem = $params->get('maxitem',0);
		$bootstrap = $params->get('bootstrap','bootstrap2');
		
		$osp_countries = $params->get('osp_countries');
		$state_ids = $params->get('state_ids');
		$city_ids = $params->get('city_ids');
        
		if($params->get('useCache') == 1){
			$data  = self::Cache( 'ospropertymap.json', $params->get('cacheTime'),'',$osp_category,$osp_type,$osp_countries,$state_ids,$city_ids,$maxitem,$bootstrap,$params,$module_id );
			$items = json_decode($data);
		}else{
			$items = self::loadAllProperty($osp_category,$osp_type,$osp_countries,$state_ids,$city_ids,$maxitem,$bootstrap,$params);
		}
		
        
        $bingkey = $bing_api;
        $latlng = $items[0]->lat_add . "," . $items[0]->long_add;
        $map = $map_type;
        $str = null;
        $result = "";
        $address = null;
        $s = null;
        $cluster = 1;
        $loc = null;
        $q = 0;
        $v = rand();
       
        if (empty($width)) {
            $width = self::formatField(JRequest::getVar('viewwidth', ($params->get('width', '100%'))));
        } else {
            $width = self::formatField($width);
        }
        if (empty($height)) {
            $height = self::formatField(JRequest::getVar('viewheight', ($params->get('height', 400))));
        } else {
            $height = self::formatField($height);
        }
        if (!empty($map_type)) {
            if ($map_type == "bing") {
                $map = 1;
            } else {
                $map = 0;
            }
        }
        if (empty($items[0]->google_maptype)) {
            $items[0]->google_maptype = 'ROADMAP';
        }
        if (empty($items[0]->bing_maptype)) {
            $items[0]->bing_maptype = 'road';
        }
        $result.= "  <script type='text/javascript'> var icons_" . $v . "=[];";
		$tempArr = array();
        foreach ($items as $item) {
            $address = "";
            $s = $item->id . "_" . $v;
            $data = array();
            if(file_exists(JPATH_ROOT.'/modules/mod_ospropertymap/asset/'.$item->category_id.'.png')){
            	$icons = JURI::root().'modules/mod_ospropertymap/asset/'.$item->category_id.'.png';
            }else{
                $icons = "https://chart.googleapis.com/chart?chst=d_map_pin_letter&chld=1|FF776B|000000";
            }
            $address = $item->infowindow;
            $tempArr[] ="['" . $address . "', " . $item->lat_add . ", " . $item->long_add . ", 6]";
            if(file_exists(JPATH_ROOT.'/modules/mod_ospropertymap/asset/'.$item->category_id.'.png')){
                $result.="icons_" . $v . "[" . $q . "]='" . JURI::root().'modules/mod_ospropertymap/asset/'.$item->category_id.'.png' . "';";
            } else {
                $result.="icons_" . $v . "[" . $q . "]='https://chart.googleapis.com/chart?chst=d_map_pin_letter&chld=" . ($q + 1) . "|FF776B|000000';";
            }
            $q++;
        }
		$loc = implode(",",$tempArr);
        $result.="</script>";
        if ($map == 0) {
            //if ($params->get('map_type', 1) == 1) {
                //$dist = 'unitSystem: google.maps.UnitSystem.IMPERIAL';
            //} else {
                $dist = 'unitSystem: google.maps.UnitSystem.METRIC';
           // }
            $script1 = "";
            $script2 = "";
            $script3 = "";
            if ($cluster == 1) {
                $script1 = "<script
    type='text/javascript' src='http://google-maps-utility-library-v3.googlecode.com/svn/trunk/markerclusterer/src/markerclusterer.js'></script>";
                $script2 = "gmarkers.push(marker);";
                $script3 = "var mcOptions = {gridSize: 50, maxZoom: 14};
		var markerCluster = new MarkerClusterer(map" . $s . ",gmarkers,mcOptions);";
            }
			$task = JRequest::getVar('task');
			if($task != "property_details"){
				$result.="<script src='https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false" . self::addLocalization() . "'></script>";
			}
            $result.="<style type='text/css'>.map_canvas img, #map img
	{
    max-width: none !important;
	}
	.map-route
	{
		margin-right:3px;
		margin-bottom:3px;
	}
	.map-route .input-medium
	{
	border-radius:2px;
	margin-right:3px;
	margin-bottom:3px;
	}
	.map-route .btn-info
	{
		padding:4px;
		margin-bottom:3px;
	}
	.map-route .btn-inverse
	{
		background:#888 !important;
		border-color:#888 !important;
		
	}
.btn {
	display: inline-block;
	*display: inline;
	*zoom: 1;
	padding: 4px 12px;
	margin-bottom: 0;
	font-size: 13px;
	line-height: 18px;
	text-align: center;
	vertical-align: middle;
	cursor: pointer;
	color: #333;
	text-shadow: 0 1px 1px rgba(255,255,255,0.75);
	background-color: #f5f5f5;
	background-image: -moz-linear-gradient(top,#fff,#e6e6e6);
	background-image: -webkit-gradient(linear,0 0,0 100%,from(#fff),to(#e6e6e6));
	background-image: -webkit-linear-gradient(top,#fff,#e6e6e6);
	background-image: -o-linear-gradient(top,#fff,#e6e6e6);
	background-image: linear-gradient(to bottom,#fff,#e6e6e6);
	background-repeat: repeat-x;
	filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffffffff', endColorstr='#ffe5e5e5', GradientType=0);
	border-color: #e6e6e6 #e6e6e6 #bfbfbf;
	*background-color: #e6e6e6;
	filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
	border: 1px solid #bbb;
	*border: 0;
	border-bottom-color: #a2a2a2;
	-webkit-border-radius: 4px;
	-moz-border-radius: 4px;
	border-radius: 4px;
	*margin-left: .3em;
	-webkit-box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
	-moz-box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
	box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
}
	</style>" . $script1 . "
    <script type='text/javascript'>
    google.maps.event.addDomListener(window, 'load', initialize" . $s . ");
      var marker" . $s . ";
      var map" . $s . ";
        var locations" . $s . " = [" . $loc . "];
            var panorama" . $s . ";
	var mapOptions" . $s . ";
      function initialize" . $s . "() {
       var total=locations" . $s . ".length;
       if(total>1)
	{
	var bounds" . $s . " = new google.maps.LatLngBounds();
	}
	var location" . $s . " = new google.maps.LatLng(" . $latlng . ");
        mapOptions" . $s . " = {
          zoom: " . $zoom . ",
          mapTypeId: google.maps.MapTypeId." . $items[0]->google_maptype . ",
          center: location" . $s . "
        };

        map" . $s . " = new google.maps.Map(document.getElementById('map_canvas_" . $s . "'),
                mapOptions" . $s . ");
	
	infowindow" . $s . " = new google.maps.InfoWindow();
	
	    var i;
	var gmarkers = [];
	    for (i = 0; i < locations" . $s . ".length; i++) {  
	      marker = new google.maps.Marker({
		position: new google.maps.LatLng(locations" . $s . "[i][1], locations" . $s . "[i][2]),
		map: map" . $s . ",
		icon:icons_" . $v . "[i],
		center: new google.maps.LatLng(" . $items[0]->lat_add . "," . $items[0]->long_add . "),
	      });
	      " . $script2 . "
	      google.maps.event.addListener(marker, 'click', (function(marker" . $s . ", i) {
		return function() {
		  infowindow" . $s . ".setContent(locations" . $s . "[i][0]);
		  infowindow" . $s . ".open(map" . $s . ", marker" . $s . ");
		}
	      })(marker, i));
	      if(total>1)
		{
	      bounds" . $s . ".extend(marker.getPosition());
	      }
	    }
            panorama" . $s . " = map" . $s . ".getStreetView();
  panorama" . $s . ".setPosition(location" . $s . ");
  panorama" . $s . ".setPov(/** @type {google.maps.StreetViewPov} */({
    heading: 265,
    pitch: 0
  }));
	if(total>1)
		{
		 map" . $s . ".fitBounds(bounds" . $s . ");
		 map" . $s . ".panToBounds(bounds" . $s . ");
		}
		" . $script3 . "
	  }
	    function launchInfoWindow(x) {
	    google.maps.event.trigger(marker" . $s . "[x], 'click');
	    var listener = google.maps.event.addListener(map, 'idle', function() { 
		    if (map.getZoom() > 15) map.setZoom(15);
		    google.maps.event.removeListener(listener); 
		 });
	    }
	    
            function toggleStreetView" . $s . "(i) {
        var cent= new google.maps.LatLng(locations" . $s . "[i][1], locations" . $s . "[i][2]);
        panorama" . $s . ".setPosition(cent);
  var toggle = panorama" . $s . ".getVisible();
    if (toggle == false) {
   panorama" . $s . ".setVisible(true);
     } else {
    panorama" . $s . ".setVisible(false);
     }
    }
	      function backToMap" . $s . "()
            {
                initialize" . $s . "();
                document.getElementById('infobox_" . $s . "').style.display='none';
                document.getElementById('backtomap_" . $s . "').style.display='none';

            }
            function reinitialize()
            {
                 var script = document.createElement('script');
                script.type = 'text/javascript';
                script.src = 'https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&' +'callback=initialize" . $s . "';
                document.body.appendChild(script);

            }
    </script>";
            $result.="<div class='map_canvas' id='map_canvas_" . $s . "'  style='width:" . $width . ";height:" . $height . ";float:left;position:relative;'></div><div class='infobox' id='infobox_" . $s . "' style='float:left;display:none'></div><input type=\"button\" class=\"btn btn-danger\" id='backtomap_" . $s . "' style='display:none;float:left;' value=\"" . JText::_("COM_MYMAPLOCATIONS_BACK") . "\" onclick=\"backToMap" . $s . "();\"></input>";
        } else {

            $result.="<style type='text/css'>.map_canvas img, #map img
	{
    max-width: none !important;
	}
	.infobox-info
	{
		background:white;
		position:absolute;
	}
	.MapPushpinBase img
	{
	max-height:36px;
	}
	.btn {
	display: inline-block;
	*display: inline;
	*zoom: 1;
	padding: 4px 12px;
	margin-bottom: 0;
	font-size: 13px;
	line-height: 18px;
	text-align: center;
	vertical-align: middle;
	cursor: pointer;
	color: #333;
	text-shadow: 0 1px 1px rgba(255,255,255,0.75);
	background-color: #f5f5f5;
	background-image: -moz-linear-gradient(top,#fff,#e6e6e6);
	background-image: -webkit-gradient(linear,0 0,0 100%,from(#fff),to(#e6e6e6));
	background-image: -webkit-linear-gradient(top,#fff,#e6e6e6);
	background-image: -o-linear-gradient(top,#fff,#e6e6e6);
	background-image: linear-gradient(to bottom,#fff,#e6e6e6);
	background-repeat: repeat-x;
	filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffffffff', endColorstr='#ffe5e5e5', GradientType=0);
	border-color: #e6e6e6 #e6e6e6 #bfbfbf;
	*background-color: #e6e6e6;
	filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
	border: 1px solid #bbb;
	*border: 0;
	border-bottom-color: #a2a2a2;
	-webkit-border-radius: 4px;
	-moz-border-radius: 4px;
	border-radius: 4px;
	*margin-left: .3em;
	-webkit-box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
	-moz-box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
	box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
}

	</style>
	<script type='text/javascript' src='http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0'></script> 
		<script type='text/javascript'>
                window.addEventListener('load', function (){
			initialize_" . $s . "();
		});
                var map_" . $s . " = null;
                var pinInfobox_" . $s . " = null;
		locations_" . $s . " = [" . $loc . "];
            var infoboxLayer_" . $s . " = new Microsoft.Maps.EntityCollection();
            var pinInfoBox_" . $s . ";  //the pop up info box
            var pinLayer_" . $s . " = new Microsoft.Maps.EntityCollection();
         function initialize_" . $s . "()
         {
             var LLA_" . $s . " = [new Microsoft.Maps.Location(" . $items[0]->lat_add . "," . $items[0]->long_add . ")];
            var r_" . $s . " = Microsoft.Maps.LocationRect.fromLocations(LLA_" . $s . ");
            var mapOptions_" . $s . " = { credentials:'" . $bingkey . "',
                               center      : r_" . $s . ".center,
                                mapTypeId   : Microsoft.Maps.MapTypeId." . $items[0]->bing_maptype . ",
                                zoom        :" . $zoom . "
                            };
            map_" . $s . " = new Microsoft.Maps.Map(document.getElementById('map_canvas_" . $s . "'), mapOptions_" . $s . ");
        // Create the info box for the pushpin
        pinInfobox_" . $s . " = new Microsoft.Maps.Infobox(new Microsoft.Maps.Location(0, 0), { visible: false,width:500,height:100});
        infoboxLayer_" . $s . ".push(pinInfobox_" . $s . ");
        for (var i = 0 ; i <locations_" . $s . ".length; i++){
            
            //add pushpins
            var latLon_" . $s . " = new Microsoft.Maps.Location(locations_" . $s . "[i][1], locations_" . $s . "[i][2]);
            var pin_" . $s . " = new Microsoft.Maps.Pushpin(latLon_" . $s . ",null);
            pin_" . $s . ".Description =locations_" . $s . "[i][0] ; //information you want to display in the infobox
            pinLayer_" . $s . ".push(pin_" . $s . "); //add pushpin to pinLayer
            Microsoft.Maps.Events.addHandler(pin_" . $s . ", 'click', displayInfobox_" . $s . ");
        }
        map_" . $s . ".entities.push(pinLayer_" . $s . ");
            map_" . $s . ".entities.push(infoboxLayer_" . $s . ");
        }

         function displayInfobox_" . $s . "(e) {   
        pinInfobox_" . $s . ".setOptions({ description: e.target.Description, visible:true,offset:new Microsoft.Maps.Point(0,25),showPointer: true});
        pinInfobox_" . $s . ".setLocation(e.target.getLocation());
        }

    function hideInfobox_" . $s . "(e) {
        pinInfobox_" . $s . ".setOptions({ visible: false });
        }
      function launchInfoWindow_" . $s . "(x) {
                var q=x-1;
                var latLon = new Microsoft.Maps.Location(locations[q][1], locations[q][2]);
                 pinInfobox_" . $s . ".setOptions({ description: locations[q][0], visible:true, offset: new Microsoft.Maps.Point(0,25)});
                 pinInfobox_" . $s . ".setLocation(latLon);
            }
    </script>";
            $result.="<div class='map_canvas' id='map_canvas_" . $s . "'  style='width:" . $width . ";height:" . $height . ";float:left;position:relative;'></div>";
        }
        return $result;
    }


    public static function formatField($field) {
        if (is_numeric($field)) {
            $field = $field . "px";
        }
        return $field;
    }

    public static function addLocalization() {
        $language = JFactory::getLanguage();
        $tag = $language->getTag();
        $lang = "";
        if (strpos($tag, 'ar') !== false) {
            $lang = "&language=ar";
        } else if (strpos($tag, 'eu') !== false) {
            $lang = "&language=eu";
        } else if (strpos($tag, 'bg') !== false) {
            $lang = "&language=bg";
        } else if (strpos($tag, 'bn') !== false) {
            $lang = "&language=bn";
        } else if (strpos($tag, 'ca') !== false) {
            $lang = "&language=ca";
        } else if (strpos($tag, 'cs') !== false) {
            $lang = "&language=cs";
        } else if (strpos($tag, 'da') !== false) {
            $lang = "&language=da";
        } else if (strpos($tag, 'de') !== false) {
            $lang = "&language=de";
        } else if (strpos($tag, 'el') !== false) {
            $lang = "&language=el";
        } else if (strpos($tag, 'es') !== false) {
            $lang = "&language=es";
        } else if (strpos($tag, 'fr') !== false) {
            $lang = "&language=fr";
        } else if (strpos($tag, 'nl') !== false) {
            $lang = "&language=nl";
        } else if (strpos($tag, 'it') !== false) {
            $lang = "&language=it";
        }
        return $lang;
    }
	public static function formatJS($string) {
        $str = str_replace("\n", '\n', str_replace('"', '\"', addcslashes(str_replace("\r", '', (string) ($string)), "\0..\37'\\")));
        return $str;
    }
    
    /**
    * Simple caching function
    * @version  1.3
    * @param string $file
    * @param string | array $datafn                  e.g:  functionname |  array( object, function) ,
    * @param array  $datafnarg    default is array  e.g:   array( arg1, arg2, ...) ,       
    * @param mixed $time         default is 900  = 15 min
    * @param mixed $onerror      string function or array(object, method )
    * @return string
    */
    public function Cache( $file, $time=900, $onerror='',$osp_category,$osp_type,$osp_countries,$state_ids,$city_ids,$maxitem,$bootstrap,$params,$module_id)
    {
    	jimport('joomla.filesystem.file');
    	jimport('joomla.filesystem.folder');
    	$moduledir = basename(dirname(__FILE__));
    	
        if (is_writable(JPATH_CACHE))
        {
            // check cache dir or create cache dir
            if (!JFolder::exists(JPATH_CACHE.'/'.$moduledir.$module_id))
            {

                JFolder::create(JPATH_CACHE.'/'.$moduledir.$module_id.'/'); 
            }

            $cache_file = JPATH_CACHE.'/'.$moduledir.$module_id.'/'.$file;

            // check cache file, if not then write cache file
            if ( !JFile::exists($cache_file) )
            {
                //$data =  call_user_func_array($datafn, $datafnarg);
                $data = self::loadAllProperty($osp_category,$osp_type,$osp_countries,$state_ids,$city_ids,$maxitem,$bootstrap,$params);
                $data = json_encode($data);
                JFile::write($cache_file, $data);
            }  
            // if cache file expires, then write cache
            elseif ( filesize($cache_file) == 0 || ((filemtime($cache_file) + (int) $time ) < time()) )
            {
                //$data =  call_user_func_array($datafn, $datafnarg);
                $data = self::loadAllProperty($osp_category,$osp_type,$osp_countries,$state_ids,$city_ids,$maxitem,$bootstrap,$params);
                $data = json_encode($data);
                JFile::write($cache_file, $data);
            }
            // read cache file
            $data =  JFile::read($cache_file);
            //$params['file'] = $cache_file;
            //$params['data'] = $data;
            
            //if( !empty($onerror) ) call_user_func($onerror, $params);
            return $data;
        }
    }
}
?>
